<template lang="pug">
//- relative container
#notifications-container
  //- absolute, flexible width drawer
  md-drawer.mt-15.md-right(
    :md-active.sync="drawerVisible"
  )
    //- Making the following conditional to the "drawerVisible" variable
    //- is of paramount importance to save queries
    apollo-query.notifications(
      v-if="queryVisible"
      ref="index"
      :query="$options.listNotificationsForUserGql"
      :pollInterval="2*1000"
      @loading="(loading) => loading ? $nuxt.$loading.start() : $nuxt.$loading.finish()"
      #default="{ result: { loading, error, data }, isLoading, query }"
    )
      apollo-subscribe-to-more(
        :document="$options.onNewNotificationForUserGql"
        :updateQuery="(previousResult, { subscriptionData }) => updateQuery(previousResult, subscriptionData)"
      )
      //-
      //- Notification list and state
      //-
      .panel(style="height:100%")
        .panel-header
          md-toolbar.md-transparent(md-elevation="0")
            .md-title Notifications
            apollo-mutation(
              :mutation="$options.editInboxItemGql"
              :variables="{ pk: '', isRead: true }"
              :refetchQueries="(mutationResult) => [{ query: $options.listNotificationsForUserGql }]"
              @error="(errorObject) => $toast.error(`Error trying to modify the notification`, {icon: 'warning'})"
            )
              template(v-slot="{ mutate, loading, error }")
                md-button.ml-2.md-icon-button(
                  v-if="data && data.notificationsForUser && data.notificationsForUser.totalUnreadCount"
                  title="Mark all as read"
                  @click="mutate()"
                  @done="query.refetch()"
                )
                  <md-icon>clear_all</md-icon>
            .md-toolbar-section-end
              md-button.md-icon-button.md-dense(v-if="nativeNotificationPermission === 'granted'" @click="() => {}" title="Native notifications are enabled")
                <md-icon>desktop_windows</md-icon>
              md-button.md-icon-button.md-dense(v-else @click="requestNativeNotificationPermission()" title="Native notifications are disabled/denied by your browser")
                <md-icon>desktop_access_disabled</md-icon>
              md-button.md-icon-button.md-dense(@click="toggleDrawer" title="Collapse sidebar")
                <md-icon>keyboard_arrow_right</md-icon>
        
        .panel-body
          //- NO NOTIFICATION: LOADING. Empty state when fetching notifications
          .empty(v-if="isLoading")
            spinner(:text="$t('fetching', { thing: $options.filters.lowercase($tc('notification', 2)) })")
          //- NO NOTIFICATION: NO NOTIFICATION AT ALL.
          .empty(v-else-if="data && data.notificationsForUser && !data.notificationsForUser.totalCount")
            notify(width="240" primaryColor="rgba(var(--color-primary), 0.8)")
            p.empty-subtitle {{ $t('blank notification help') }}
          //- NO NOTIFICATION: NO UNREAD NOTIFICATION
          .empty(v-else-if="data && !data.notificationsForUser.totalUnreadCount")
            confirmation(width="140" primaryColor="rgba(var(--color-primary), 0.8)")
            p.empty-subtitle {{ $t('blank new notification help') }}
          transition-group(
            v-if="data && data.notificationsForUser && data.notificationsForUser.totalCount"
            name="notification"
            tag="ol"
          )
            li.md-list.md-triple-line.md-dense(
              v-for="(notification, index) in data.notificationsForUser.edges"
              :key="notification.node.pk"
            )
              md-divider.md-inset.divider

              apollo-mutation(
                  :mutation="$options.editInboxItemGql"
                  :variables="{ pk: notification.node.pk, isRead: !notification.node.isRead }"
                  @done="() => { notification.node.isRead = !notification.node.isRead }"
                  @error="(errorObject) => $toast.error(`Error trying to modify the notification`, {icon: 'warning'})"
                )
                  template(v-slot="{ mutate, loading, error }")

                    md-list-item(
                      :to="notification.node.url"
                      @click="() => notification.node.isRead === false && mutate()"
                      :title="notification.node.activity.payload.object.summary"
                      :class="{ 'read': notification.node.isRead }"
                    )
                      avatar(v-if="notification.node.actor.icon" :src="notification.node.actor.icon.url || notification.node.actor.icon")

                      .md-list-item-text
                        span(v-html="notification.node.activity.payload.object.summary")
                        p(v-html="notification.node.activity.payload.object.content")
                        timeago(:datetime="new Date(notification.node.activity.payload.object.published)" :auto-update="20" style="font-size:75%;")

                      md-button.md-icon-button.md-list-action.mr-1(
                        v-if="notification.node.isRead"
                        title="Mark as unread"
                        :disabled="loading"
                        @click="mutate()"
                      )
                        md-icon drafts
                      md-button.md-icon-button.md-list-action.mr-1(
                        v-else
                        title="Mark as read"
                        :disabled="loading"
                        @click="mutate()"
                      )
                        md-icon email
        .panel-footer
          .mt-10
            md-button(v-if="data && data.notificationsForUser && data.notificationsForUser.pageInfo.hasNextPage" title="Load more, older notifications") load more
            apollo-mutation(
              :mutation="$options.editInboxItemGql"
              :variables="{ pk: '', isRead: true }"
              :refetchQueries="(mutationResult) => [{ query: $options.listNotificationsForUserGql }]"
              @error="(errorObject) => $toast.error(`Error trying to modify the notification`, {icon: 'warning'})"
            )
              template(v-slot="{ mutate, loading, error }")
                md-button(
                  v-if="data && data.notificationsForUser && data.notificationsForUser.totalUnreadCount"
                  title="Mark all as read"
                  @click="mutate()"
                  @done="query.refetch()"
                ) mark all read
</template>

<script>
import Vue from 'vue'
import VueTimeago from 'vue-timeago'
import Notify from 'vue-undraw/UndrawNotify'
import Confirmation from 'vue-undraw/UndrawConfirmation'

import Spinner from '~/components/Spinner.vue'
import Avatar from '~/components/Avatar'

import listNotificationsForUserGql from '~/apollo/queries/listNotificationsForUser'
import editInboxItemGql from '~/apollo/mutations/editInboxItem'
import onNewNotificationForUserGql from '~/apollo/subscriptions/onNewNotificationForUser'

Vue.use(VueTimeago, {
  name: 'Timeago'
})

export default {
  listNotificationsForUserGql,
  editInboxItemGql,
  onNewNotificationForUserGql,

  components: {
    Avatar,
    Confirmation,
    Notify,
    Spinner
  },
  data() {
    return {
      drawerVisible: false,
      queryVisible: false,
      VuexUnsubscription: null,
      nativeNotificationPermission: 'default'
    }
  },
  mounted() {
    this.nativeNotificationPermission = window.Notification.permission
    // We subscribe to some events outside of the component (i.e.: external request to refresh)
    this.VuexUnsubscription = this.$store.subscribeAction((action, state) => {
      if (action.type === 'user/DRAWER_TOGGLE') {
        this.$nextTick(() => {
          this.toggleDrawer()
        })
      }
    })
  },
  destroyed() {
    this.VuexUnsubscription()
  },
  methods: {
    updateQuery(previousResult, subscriptionData) {
      const newResult = { ...previousResult }
      newResult.notificationsForUser.totalCount += 1
      newResult.notificationsForUser.totalUnreadCount += 1
      newResult.notificationsForUser.edges.splice(0, 0, {
        node: subscriptionData.data.onNewNotificationForUser.notification
      })
      return newResult
    },
    toggleDrawer() {
      this.drawerVisible = !this.drawerVisible
      // the following is just to add enough temporisation for the
      // component's sidebar to gracefully transition with content
      if (this.drawerVisible === false) {
        setTimeout(() => {
          this.queryVisible = this.drawerVisible
        }, 1000)
      } else {
        this.queryVisible = this.drawerVisible
      }
    },
    requestNativeNotificationPermission() {
      this.$notification.requestPermission().then(value => {
        this.nativeNotificationPermission = value
      })
    },
    revokeNativeNotificationPermission() {
      // TODO: the navigator.permissions.revoke() API is disabled, so we have to use localStorage to store the user's decision not to be notified natively.
    }
  }
}
</script>

<style scoped>
#notifications-container {
  position: relative;
}
.notifications {
  height: 100%;
  min-width: 25vw;
}
.md-drawer {
  background: rgba(var(--color-background));
  border: none;
  box-shadow: -20px 0 10px -10px rgba(0, 0, 0, 0.06) !important;
  border: none !important;
  width: unset;
  max-width: 400px;
}
.md-list-item.read {
  opacity: 0.6;
}
.md-list-action {
  align-self: unset !important;
}
.md-dense {
  padding: 1px 0;
}
.divider {
  margin-bottom: 0;
}
.panel {
  border: none;
  overflow: hidden;
  min-width: 320px;
}
ol,
li {
  margin: 0;
}
.notification-enter-active,
.notification-leave-active {
  transition: all 1s;
}
.notification-enter, .notification-leave-to /* .list-leave-active below version 2.1.8 */ {
  opacity: 0;
  transform: translateY(-30px);
}
.notification-list-move {
  transition: transform 1s;
}
</style>
<style>
.md-drawer.md-persistent-mini:not(.md-active) {
  width: 0px !important;
}
.panel .panel-footer,
.panel .panel-header,
.panel .panel-body {
  padding: 0;
}
</style>
